/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.1.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <cstrike>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>

enum (<<= 1)
{
	g_iEnumBitLastH = 1,
	g_iEnumBitLastZ
}

new g_pCvar_Last, g_pCvar_Limit, g_pCvar_Cost,
g_iCachedCvarLast, g_iCachedCvarLimit, g_iCachedCvarCost,
g_iLastHumanID, g_iLastZombieID, g_iRespawns[33],
g_iBsAlive;

public plugin_init()
{
	register_plugin("[ZPNM] Buy respawn", "1.1.3", "D i 5 7 i n c T")
	
	register_dictionary("zombie_plague.txt")
	
	register_event("HLTV", "fwEventHltvRoundStart", "a", "1=0", "2=0")
	
	register_clcmd("say /respawn", "fwClCmdSayRespawn")
	register_clcmd("say_team /respawn", "fwClCmdSayRespawn")
	register_clcmd("say /zspawn", "fwClCmdSayRespawn")
	register_clcmd("say_team /zspawn", "fwClCmdSayRespawn")
	
	RegisterHam(Ham_Spawn, "player", "fwHamSpawnPlayer", 1)
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Spawn, "fwHamSpawnPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	g_pCvar_Last = register_cvar("zpnm_respawn_after_last", "0");
	g_pCvar_Limit = register_cvar("zpnm_respawn_limit", "1");
	g_pCvar_Cost = register_cvar("zpnm_respawn_cost", "17");
}

public fwEventHltvRoundStart()
{
	g_iCachedCvarLast = get_pcvar_num(g_pCvar_Last);
	g_iCachedCvarLimit = get_pcvar_num(g_pCvar_Limit);
	g_iCachedCvarCost = get_pcvar_num(g_pCvar_Cost);
	
	g_iLastHumanID = 0;
	g_iLastZombieID = 0;
	
	static iMaxPlayers;
	
	if (!iMaxPlayers)
		iMaxPlayers = get_maxplayers();
	
	for (new i = 1; i <= iMaxPlayers; i++)
		g_iRespawns[i] = 0;
}

public client_disconnect(iID)
{
	bitsum_del(g_iBsAlive, iID)
	
	g_iRespawns[iID] = 0;
	
	if (iID == g_iLastHumanID)
		g_iLastHumanID = 0;
	else if (iID == g_iLastZombieID)
		g_iLastZombieID = 0;
}

public fwHamSpawnPlayer(iID)
{
	if (!is_user_alive(iID))
		return;
	
	bitsum_add(g_iBsAlive, iID)
	
	g_iLastHumanID = 0;
}

public zp_user_infected_pre(iID)
{
	if (zp_get_user_zombie(iID))
		return;
	
	g_iLastZombieID = 0;
}

public zp_user_humanized_pre(iID)
{
	if (!zp_get_user_zombie(iID))
		return;
	
	g_iLastHumanID = 0;
}

public zp_user_last_human(iID)
{
	g_iLastHumanID = iID;
}

public zp_user_last_zombie(iID)
{
	g_iLastZombieID = iID;
}

public fwHamKilledPlayer(iID, iAttackerID)
{
	bitsum_del(g_iBsAlive, iID)
	
	if (iID == g_iLastHumanID)
		g_iLastHumanID = 0;
	else if (iID == g_iLastZombieID)
		g_iLastZombieID = 0;
}

public fwClCmdSayRespawn(id)
{
	if (bitsum_get(g_iBsAlive, id))
		return;
	else if (g_iRespawns[id] >= g_iCachedCvarLimit)
	{
		colored_chat(id, "^3You have used ^1%d^3/^1%d ^3respawns this round^1!", g_iRespawns[id], g_iCachedCvarLimit)
		
		return;
	}
	else if (g_iLastHumanID && !(g_iCachedCvarLast & g_iEnumBitLastH))
	{
		colored_chat(id, "^3You can't respawn because player ^1%d ^3is the last human^1!", g_iLastHumanID)
		
		return;
	}
	else if (g_iLastZombieID && !(g_iCachedCvarLast & g_iEnumBitLastZ))
	{
		colored_chat(id, "^3You can't respawn because player ^1%d ^3is the last zombie^1!", g_iLastHumanID)
		
		return;
	}
	
	new CsTeams:iTeam = cs_get_user_team(id);
	
	if (iTeam == CS_TEAM_SPECTATOR
	|| iTeam == CS_TEAM_UNASSIGNED)
		return;
	
	new iAmmoPacks = zp_get_user_ammo_packs(id);
	
	if (iAmmoPacks < g_iCachedCvarCost)
	{
		colored_chat(id, "^3%L^1(^3%d^1/^4%d^1)", id, "NOT_ENOUGH_AMMO", iAmmoPacks, g_iCachedCvarCost)
		
		return;
	}
	
	zp_set_user_ammo_packs(id, iAmmoPacks - g_iCachedCvarCost)
	
//	zp_respawn_user(id)
	ExecuteHamB(Ham_CS_RoundRespawn, id)
	
	g_iRespawns[id]++;
}

stock colored_chat(const iTarget, const szMessage[], any:...)
{
	if (!is_user_connected(iTarget))
		return;
	
	static szBuffer[192];
	
	// Format message for player
	vformat(szBuffer, charsmax(szBuffer), szMessage, 3)
	
	static const D7_CHAT_TAG[] = "^1[^4ZPNM^1] ";
	
	format(szBuffer, charsmax(szBuffer), "%s%s", D7_CHAT_TAG, szBuffer)
	
	static msgSayText;
	
	if (!msgSayText)
		msgSayText = get_user_msgid("SayText");
	
	message_begin(MSG_ONE, msgSayText, _, iTarget)
	write_byte(iTarget)
	write_string(szBuffer)
	message_end()
}
