/*
To do:

T = needs testing
X = done
- = cancelled

[X] fix players not gibbing due to wrong param value set
[T] enum instead of defining each bit as a constant
v0.0.9
[T] CZ bots support
v0.1.0
[T] see if we need to define the 3rd killed parameter at all and remove if not
[T] letters instead of numbers for cvar
[T] block corpse message if victim is gibbed
v0.1.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>

new g_iIDPCvarBitsumGib, g_iBsCorpseBlock;

enum (<<= 1)
{
	g_iBitHumanVictim = 1,
	g_iBitHumanAttacker,
	g_iBitSurvivorVictim,
	g_iBitSurvivorAttacker,
	g_iBitSniperVictim,
	g_iBitSniperAttacker,
	g_iBitZombieVictim,
	g_iBitZombieAttacker,
	g_iBitNemesisVictim,
	g_iBitNemesisAttacker,
	g_iBitAssassinVictim,
	g_iBitAssassinAttacker
}

public plugin_init()
{
	register_plugin("[ZPNM] Death gib", "0.1.3", "D i 5 7 i n c T, GHW_Chronic")
	
	register_message(get_user_msgid("ClCorpse"), "fwMsgClCorpsePre")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayerPre")
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayerPre")
	
	g_iIDPCvarBitsumGib = register_cvar("zpnm_death_gib", "fikl");//3680
}

public fwMsgClCorpsePre()
{
	if (!bitsum_get(g_iBsCorpseBlock, get_msg_arg_int(12)))
		return PLUGIN_CONTINUE;
	
	return PLUGIN_HANDLED;
}

public fwHamKilledPlayerPre(const iIDVictim, const iIDAttacker, const iShouldGib)
{
	static szCVar[15];
	get_pcvar_string(g_iIDPCvarBitsumGib, szCVar, charsmax(szCVar))
	
	new iBsShouldGib = read_flags(szCVar);
	
	if (!iBsShouldGib)
		return;
	
	new bNemesis = zp_get_user_nemesis(iIDVictim),
	bAssassin = zpnm_get_user_assassin(iIDVictim),
	bZombie = (zp_get_user_zombie(iIDVictim) && !bNemesis && !bAssassin) ? true : false,
	bSurvivor = zp_get_user_survivor(iIDVictim),
	bSniper = zpnm_get_user_sniper(iIDVictim),
	bHuman = (!bZombie && !bNemesis && !bAssassin && !bSurvivor && !bSniper) ? true : false;
	
	if (bZombie && (iBsShouldGib & g_iBitZombieVictim) || bNemesis && (iBsShouldGib & g_iBitNemesisVictim)
	|| bAssassin && (iBsShouldGib & g_iBitAssassinVictim) || bHuman && (iBsShouldGib & g_iBitHumanVictim)
	|| bSurvivor && (iBsShouldGib & g_iBitSurvivorVictim) || bSniper && (iBsShouldGib & g_iBitSniperVictim))
	{
		bitsum_add(g_iBsCorpseBlock, iIDVictim)
		
		SetHamParamInteger(3, 2)
	}
	else if (iShouldGib < 2)
	{
		bitsum_del(g_iBsCorpseBlock, iIDVictim)
	}
	
	if (iIDVictim == iIDAttacker || !is_user_connected(iIDAttacker))
		return;
	
	bNemesis = zp_get_user_nemesis(iIDAttacker),
	bAssassin = zpnm_get_user_assassin(iIDAttacker),
	bZombie = (zp_get_user_zombie(iIDAttacker) && !bNemesis && !bAssassin) ? true : false,
	bSurvivor = zp_get_user_survivor(iIDAttacker),
	bSniper = zpnm_get_user_sniper(iIDAttacker),
	bHuman = (!bZombie && !bNemesis && !bAssassin && !bSurvivor && !bSniper) ? true : false;
	
	if (bZombie && (iBsShouldGib & g_iBitZombieAttacker) || bNemesis && (iBsShouldGib & g_iBitNemesisAttacker)
	|| bAssassin && (iBsShouldGib & g_iBitAssassinAttacker) || bHuman && (iBsShouldGib & g_iBitHumanAttacker)
	|| bSurvivor && (iBsShouldGib & g_iBitSurvivorAttacker) || bSniper && (iBsShouldGib & g_iBitSniperAttacker)
	&& get_user_weapon(iIDAttacker) == CSW_AWP)
	{
		bitsum_add(g_iBsCorpseBlock, iIDVictim)
		
		SetHamParamInteger(3, 2)
	}
	else if (iShouldGib < 2)
	{
		bitsum_del(g_iBsCorpseBlock, iIDVictim)
	}
}
