/*
To do:

T = needs testing
X = done
- = cancelled

[T] CZ bots support
v1.0.8
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new g_bitPlayerFlashlight, g_iMaxPlayers

//new g_iAttenuation = 5;
//new g_iDistanceMax = 2000;

#define MarkPlayerFlashLight(%0)	g_bitPlayerFlashlight |= 1<<(%0&31)
#define ClearPlayerFlashLight(%0)	g_bitPlayerFlashlight &= ~(1<<(%0&31))
#define HasPlayerFlashLightOn(%0)	(g_bitPlayerFlashlight & 1<<(%0&31))

public plugin_init()
{
	register_plugin("[ZPNM] Flashlight Fix", "1.0.8", "ConnorMcLeod, schmurgel1983, D i 5 7 i n c T")
	
	register_event("Flashlight", "Event_Flashlight", "b")
	register_event("StatusValue", "ShowStatus", "be", "1=2", "2!0")
	register_event("StatusValue", "HideStatus", "be", "1=1", "2=0")
	
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn")
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled")
	RegisterHamBots(Ham_Spawn, "fw_PlayerSpawn")
	RegisterHamBots(Ham_Killed, "fw_PlayerKilled")
	
	g_iMaxPlayers = get_maxplayers();
}

public client_disconnect(iID)
{
	remove_task(iID)
	ClearPlayerFlashLight(iID)
}

public fw_PlayerSpawn(const iID)
{
	remove_task(iID)
	ClearPlayerFlashLight(iID)
}

public fw_PlayerKilled(const iID)
{
	remove_task(iID)
	ClearPlayerFlashLight(iID)
}

public Event_Flashlight(iID)
{
	if (read_data(1))
	{
		MarkPlayerFlashLight(iID)
		
		new iAim, iDummy;
		get_user_aiming(iID, iAim, iDummy)
		
		if (iAim < 1 || iAim > g_iMaxPlayers || !is_user_alive(iAim)) // || HasPlayerFlashLightOn(iAim)
			return;
		
		LightTarget(iID)
		set_task(0.1, "LightTarget", iID, _, _, "b")
	}
	else
	{
		remove_task(iID)
		ClearPlayerFlashLight(iID)
	}
}

public ShowStatus(iID)
{
	if (!HasPlayerFlashLightOn(iID))
		return;
	
	new iAim = read_data(2);
    
	if (iAim < 1 || iAim > g_iMaxPlayers || !is_user_alive(iAim)) // || HasPlayerFlashLightOn(iAim)
		return;
	
	LightTarget(iID)
	set_task(0.1, "LightTarget", iID, _, _, "b")
}

public HideStatus(iID)
	remove_task(iID)

public LightTarget(iID)
{
	static /*szOrigin[3], */szAimOrigin[3]
//	get_user_origin(iID, szOrigin, 1)
	get_user_origin(iID, szAimOrigin, 3)
/*	
	static iDecay, iAttn
	
	iDecay = iDist * 255 / g_iDistanceMax;
	iAttn = 256 + iDecay * g_iAttenuation;*/
	
	message_begin(MSG_PVS/*BROADCAST*/, SVC_TEMPENTITY, szAimOrigin)
	write_byte(TE_DLIGHT) // TE iID
	write_coord(szAimOrigin[0]) // x
	write_coord(szAimOrigin[1]) // y
	write_coord(szAimOrigin[2]) // z
	write_byte(9) // radius
	write_byte(255) // (r<<8)/iAttn
	write_byte(255) // (g<<8)/iAttn
	write_byte(255) // (b<<8)/iAttn
	write_byte(3) // life(for prethink set to 1)
	write_byte(0) // iDecay decay rate
	message_end()
}
