/*
To do:

T = needs testing
X = done
- = cancelled

[T] display at the end of the round instead to avoid filling the chat on round start + customizability?
[T] optimize
[T] change print style
[T] update print stock
[T] descriptive variable and event names
[T] global maxplayers
[T] custom number of leaders to look for
[T] fix wrong formatting which could lead to overflowed clients
v1.3.1
[ ] 
*/

// Modules
#include <amxmodx>

// Plug-in APIs
#include <zombieplague>

// Stocks
#include <bitsums>

new g_iIDPCvarShow, g_iIDPCvarCount, g_iMaxPlayers, g_iIDMsgSayText, g_bRoundEnded, g_iBsConnected;

enum
{
	g_iSetDisplayNot,
	g_iSetDisplayRoundStart,
	g_iSetDisplayWelcomeMessage,
	g_iSetDisplayRoundEnd
}

public plugin_init()
{
	register_plugin("[ZPNM] Frags/packs leader(s)", "1.3.1", "D i 5 7 i n c T")
	
	register_dictionary("zpnm_frags-packs_leader(s).txt")
	
	register_event("HLTV", "fwEvHLTVRoundStart", "a", "1=0", "2=0")
	register_event("TextMsg", "fwEvRoundEnd", "a", "2=#Game_Commencing")
	register_event("TextMsg", "fwEvRoundEnd", "a", "2=#Game_will_restart_in")
	
	register_logevent("fwEvRoundEnd", 2, "1=Round_End")
	
	g_iIDPCvarShow = register_cvar("D7FragsPacksLeadersShow", "3")
	g_iIDPCvarCount = register_cvar("D7FragsPacksLeadersCount", "2")
	
	g_iMaxPlayers = get_maxplayers();
	
	g_iIDMsgSayText = get_user_msgid("SayText");
}

public fwEvHLTVRoundStart()
{
	g_bRoundEnded = 0;
	
	new iCvarShow = get_pcvar_num(g_iIDPCvarShow);//clamp(get_pcvar_num(g_iIDPCvarShow), g_iSetDisplayNot, g_iSetDisplayRoundEnd)
	
	//if (iCvarShow == g_iSetDisplayNot || iCvarShow == g_iSetDisplayRoundEnd)
		//return;
	
	//remove_task()
	
	if (iCvarShow == g_iSetDisplayRoundStart)
	{
		remove_task()
		fwTaskDisplayLeaders()
	}
	else if (iCvarShow == g_iSetDisplayWelcomeMessage)
	{
		remove_task()
		set_task(2.1975, "fwTaskDisplayLeaders")
	}
}

public fwEvRoundEnd()
{
	if (g_bRoundEnded)
		return;
	
	g_bRoundEnded = 1;
	
	if (get_pcvar_num(g_iIDPCvarShow) != g_iSetDisplayRoundEnd)
		return;
	
	remove_task()
	fwTaskDisplayLeaders()
}

public client_putinserver(iID)
	bitsum_add(g_iBsConnected, iID)

public client_disconnect(iID)
	bitsum_del(g_iBsConnected, iID)

public fwTaskDisplayLeaders()
{
	new iID, iTemp, szCountMostFrags[3], szIDsLeadersFrags[3], szCountMostPacks[3], szIDsLeadersPacks[3], iCvarCount = clamp(get_pcvar_num(g_iIDPCvarCount), 1, 3);
	
	for (iID = 1; iID <= g_iMaxPlayers; iID++)
	{
		if (!bitsum_get(g_iBsConnected, iID))
			continue;
		
		iTemp = get_user_frags(iID)
/*		
		if (iCvarCount == 1)
		{
			if (iTemp > szCountMostFrags[0])
			{
				szIDsLeadersFrags[0] = iID;
				szCountMostFrags[0] = iTemp;
			}
		}
		else if (iCvarCount == 2)
		{
			if (iTemp > szCountMostFrags[0])
			{
				szIDsLeadersFrags[1] = szIDsLeadersFrags[0];
				szCountMostFrags[1] = szCountMostFrags[0];
				
				szIDsLeadersFrags[0] = iID;
				szCountMostFrags[0] = iTemp;
			}
			else if (iTemp > szCountMostFrags[1])
			{
				szIDsLeadersFrags[1] = iID;
				szCountMostFrags[1] = iTemp;
			}
		}
		else if (iCvarCount == 3)
		{
			if (iTemp > szCountMostFrags[0])
			{
				szIDsLeadersFrags[2] = szIDsLeadersFrags[1];
				szCountMostFrags[2] = szCountMostFrags[1];
				
				szIDsLeadersFrags[1] = szIDsLeadersFrags[0];
				szCountMostFrags[1] = szCountMostFrags[0];
				
				szIDsLeadersFrags[0] = iID;
				szCountMostFrags[0] = iTemp;
			}
			else if (iTemp > szCountMostFrags[1])
			{
				szIDsLeadersFrags[2] = szIDsLeadersFrags[1];
				szCountMostFrags[2] = szCountMostFrags[1];
				
				szIDsLeadersFrags[1] = iID;
				szCountMostFrags[1] = iTemp;
			}
			else if (iTemp > szCountMostFrags[2])
			{
				szIDsLeadersFrags[2] = iID;
				szCountMostFrags[2] = iTemp;
			}
		}*/
		
		if (iTemp > szCountMostFrags[0])
		{
			if (iCvarCount > 1)
			{
				if (iCvarCount == 3)
				{
					szIDsLeadersFrags[2] = szIDsLeadersFrags[1];
					szCountMostFrags[2] = szCountMostFrags[1];
				}
				
				szIDsLeadersFrags[1] = szIDsLeadersFrags[0];
				szCountMostFrags[1] = szCountMostFrags[0];
			}
			
			szIDsLeadersFrags[0] = iID;
			szCountMostFrags[0] = iTemp;
		}
		else if (iCvarCount > 1)
		{
			if (iTemp > szCountMostFrags[1])
			{
				if (iCvarCount == 3)
				{
					szIDsLeadersFrags[2] = szIDsLeadersFrags[1];
					szCountMostFrags[2] = szCountMostFrags[1];
				}
				
				szIDsLeadersFrags[1] = iID;
				szCountMostFrags[1] = iTemp;
			}
			else if (iCvarCount == 3 && iTemp > szCountMostFrags[2])
			{
				szIDsLeadersFrags[2] = iID;
				szCountMostFrags[2] = iTemp;
			}
		}
		
		iTemp = zp_get_user_ammo_packs(iID)
		
		if (iTemp > szCountMostPacks[0])
		{
			if (iCvarCount > 1)
			{
				if (iCvarCount == 3)
				{
					szIDsLeadersPacks[2] = szIDsLeadersPacks[1];
					szCountMostPacks[2] = szCountMostPacks[1];
				}
				
				szIDsLeadersPacks[1] = szIDsLeadersPacks[0];
				szCountMostPacks[1] = szCountMostPacks[0];
			}
			
			szIDsLeadersPacks[0] = iID;
			szCountMostPacks[0] = iTemp;
		}
		else if (iCvarCount > 1)
		{
			if (iTemp > szCountMostPacks[1])
			{
				if (iCvarCount == 3)
				{
					szIDsLeadersPacks[2] = szIDsLeadersPacks[1];
					szCountMostPacks[2] = szCountMostPacks[1];
				}
				
				szIDsLeadersPacks[1] = iID;
				szCountMostPacks[1] = iTemp;
			}
			else if (iCvarCount == 3 && iTemp > szCountMostPacks[2])
			{
				szIDsLeadersPacks[2] = iID;
				szCountMostPacks[2] = iTemp;
			}
		}
	}
	
	if (!szIDsLeadersFrags[0] && !szIDsLeadersPacks[0])
		return;
	
	static szNamesValuesLeadersFrags[(32 * 3) + (9 * 3) + (11 * 3) + (5 * 2)];
	
	if (szIDsLeadersFrags[0])
	{
		iTemp = 0;
		
		iTemp += get_user_name(szIDsLeadersFrags[0], szNamesValuesLeadersFrags[iTemp], charsmax(szNamesValuesLeadersFrags) - iTemp);
		
		iTemp += formatex(szNamesValuesLeadersFrags[iTemp], charsmax(szNamesValuesLeadersFrags) - iTemp, "^1(^4%d^1)", szCountMostFrags[0]);
		
		if (iCvarCount > 1 && szIDsLeadersFrags[1])
		{
			iTemp += formatex(szNamesValuesLeadersFrags[iTemp], charsmax(szNamesValuesLeadersFrags) - iTemp, ",^4 ");
			
			iTemp += get_user_name(szIDsLeadersFrags[1], szNamesValuesLeadersFrags[iTemp], charsmax(szNamesValuesLeadersFrags) - iTemp);
			
			iTemp += formatex(szNamesValuesLeadersFrags[iTemp], charsmax(szNamesValuesLeadersFrags) - iTemp, "^1(^3%d^1)", szCountMostFrags[1]);
			
			if (iCvarCount == 3 && szIDsLeadersFrags[2])
			{
				iTemp += formatex(szNamesValuesLeadersFrags[iTemp], charsmax(szNamesValuesLeadersFrags) - iTemp, ",^4 ");
				
				iTemp += get_user_name(szIDsLeadersFrags[2], szNamesValuesLeadersFrags[iTemp], charsmax(szNamesValuesLeadersFrags) - iTemp);
				
				formatex(szNamesValuesLeadersFrags[iTemp], charsmax(szNamesValuesLeadersFrags) - iTemp, "^1(^3%d^1)", szCountMostFrags[2])
			}
		}
	}
	
	static szNamesValuesLeadersPacks[(32 * 3) + (9 * 3) + (11 * 3) + (5 * 2)];
	
	if (szIDsLeadersPacks[0])
	{
		iTemp = 0;
		
		iTemp += get_user_name(szIDsLeadersPacks[0], szNamesValuesLeadersPacks[iTemp], charsmax(szNamesValuesLeadersPacks) - iTemp);
		
		iTemp += formatex(szNamesValuesLeadersPacks[iTemp], charsmax(szNamesValuesLeadersPacks) - iTemp, "^1(^4%d^1)", szCountMostPacks[0]);
		
		if (iCvarCount > 1 && szIDsLeadersPacks[1])
		{
			iTemp += formatex(szNamesValuesLeadersPacks[iTemp], charsmax(szNamesValuesLeadersPacks) - iTemp, ",^4 ");
			
			iTemp += get_user_name(szIDsLeadersPacks[1], szNamesValuesLeadersPacks[iTemp], charsmax(szNamesValuesLeadersPacks) - iTemp);
			
			iTemp += formatex(szNamesValuesLeadersPacks[iTemp], charsmax(szNamesValuesLeadersPacks) - iTemp, "^1(^3%d^1)", szCountMostPacks[1])
			
			if (iCvarCount == 3 && szIDsLeadersPacks[2])
			{
				iTemp += formatex(szNamesValuesLeadersPacks[iTemp], charsmax(szNamesValuesLeadersPacks) - iTemp, ",^4 ");
				
				iTemp += get_user_name(szIDsLeadersPacks[2], szNamesValuesLeadersPacks[iTemp], charsmax(szNamesValuesLeadersPacks) - iTemp);
				
				formatex(szNamesValuesLeadersPacks[iTemp], charsmax(szNamesValuesLeadersPacks) - iTemp, "^1(^3%d^1)", szCountMostPacks[2])
			}
		}
	}
	
	for (iID = 1; iID <= g_iMaxPlayers; iID++)
	{
		if (!bitsum_get(g_iBsConnected, iID))
			continue;
		
		if (szIDsLeadersFrags[0])
			ftClientPrintChatColor(iID, szIDsLeadersFrags[0], "^1[^4ZPNM^1]^4 %L^1:^3 %s", iID, "ZPNM_FRAGS_LEADERS", szNamesValuesLeadersFrags)
		
		if (szIDsLeadersPacks[0])
			ftClientPrintChatColor(iID, szIDsLeadersPacks[0], "^1[^4ZPNM^1]^4 %L^1:^3 %s", iID, "ZPNM_PACKS_LEADERS", szNamesValuesLeadersPacks)
	}
}

ftClientPrintChatColor(const iIDTarget, const iIDSender, const szMessage[], any:...)
{
	static szBuffer[192];
	vformat(szBuffer, charsmax(szBuffer), szMessage, 4)
	
	message_begin(MSG_ONE, g_iIDMsgSayText, _, iIDTarget)
	write_byte(iIDSender)
	write_string(szBuffer)
	message_end()
}
