/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
[T] is_user_alive
v1.2.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <zp50_colorchat>

new g_playercount, cvar_minplayers, g_canceled

public plugin_init()
{
	register_plugin("[ZPNM] Manage mode start", "1.2.3", "D i 5 7 i n c T")
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	register_dictionary("zpnm_manage_mode_start.txt")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	cvar_minplayers = register_cvar("zpnm_mode_start_min_players", "2")
}

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	cvar_minplayers = get_pcvar_num(cvar_minplayers)
//	check_player_count()
}

public event_round_start()
{
	g_playercount = 0
	g_canceled = false
	
	remove_task(57)
	set_task(get_cvar_float("zp_delay") + 1.357, "check_player_count", 57)
}

public client_disconnect(iID)
	if (zp_has_round_started() != 1 && is_user_alive(iID))
		g_playercount--

public zpnm_user_spawn_post(iID)
{
	if (zp_has_round_started() == 1)
		return;
	
	g_playercount++
	
	if (!g_canceled || g_playercount < cvar_minplayers)
		return;
	
	zpnm_set_game_mode(MODE_NONE, iID)
}

public fwHamKilledPlayer(const iID)
	if (zp_has_round_started() != 1)
		g_playercount--

public check_player_count()
{
	if (g_playercount < cvar_minplayers)
	{
		zpnm_set_game_mode(-1)
		
		g_canceled = true
		zp_colored_print(0, "^3%L", LANG_PLAYER, "ZPNM_MODE_CANCELED")
	}
}

public zp_round_started()
{
	remove_task(57)
	
	g_canceled = false
	g_playercount = 0
}
