#include <amxmodx>
#include <zp50_colorchat>
#include <zombieplaguenightmare>

new g_MsgSync, cvar_rr_hud_color, cvar_rr_time, g_countdown_seconds = 1,
g_hud_color_red, g_hud_color_green, g_hud_color_blue

new const g_countdown_sounds[][] =
{
	"",
	"vox/one",
	"vox/two",
	"vox/three",
	"vox/four",
	"vox/five",
	"vox/six",
	"vox/seven",
	"vox/eight",
	"vox/nine",
	"vox/ten",
	"", "", "", "",
	"vox/fifteen seconds remaining",
	"", "", "", "",
	"vox/twenty seconds remaining",
	"", "", "", "", "", "", "", "", "",
	"vox/thirty seconds remaining",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"vox/fifty seconds remaining"
}

const g_countdown_sounds_size = sizeof g_countdown_sounds

public plugin_init() 
{
	register_plugin("[ZPNM] Map Change Round Restarter", "1.2.1", "D i 5 7 i n c T")
	
	register_logevent("event_game_commencing", 2, "0=World triggered", "1=Game_Commencing")
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	register_dictionary("zpnm_map_change_rrst.txt")
	register_concmd("say /restart", "concmd_restart")
	
	g_MsgSync = CreateHudSyncObj()
	cvar_rr_time = register_cvar("zpnm_restart_time", "57")
	cvar_rr_hud_color = register_cvar("zpnm_restart_hud_color", "175 175 175")
}

public plugin_cfg()
	set_task(1.57, "cache_settings", 57)

public cache_settings()
{
	static color[16], red[4], green[4], blue[4]
	
	get_pcvar_string(cvar_rr_hud_color, color, 15)
	parse(color, red, 3, green, 3, blue, 3)
	
	g_hud_color_red = clamp(str_to_num(red), 0, 255)
	g_hud_color_green = clamp(str_to_num(green), 0, 255)
	g_hud_color_blue = clamp(str_to_num(blue), 0, 255)
}

public event_game_commencing()
{
	if (!g_countdown_seconds)
		return;
	
	remove_task(75)
	
	g_countdown_seconds = get_pcvar_num(cvar_rr_time)
	CountDown(75)
}

public event_round_start()
{
	if (!g_countdown_seconds)
		return;
	
	zpnm_set_game_mode(-1)
}

public zpnm_extra_item_buy_attempt(id, itemid, ignorecost)
{
	if (ignorecost || !g_countdown_seconds)
		return PLUGIN_CONTINUE;
	
	zp_colored_print(id, "%L", id, "MPR_ITEMS")
	
	return ZP_PLUGIN_HANDLED;
}

public concmd_restart(id)
{
	if (!(get_user_flags(id) & ADMIN_MAP))
		return;
	
	remove_task(75)
	
	g_countdown_seconds = 0
	CountDown(75)
	
	zp_colored_print(0, "ADMIN:^4 %L", LANG_PLAYER, "MPR_NOW")
}

public CountDown(taskid)
{
	if (g_countdown_seconds > 0)
	{
		set_hudmessage(g_hud_color_red, g_hud_color_green, g_hud_color_blue, 0.01, 0.21, 1, 1.0, 1.0, 0.1, 0.1, -1)
		ShowSyncHudMsg(0, g_MsgSync, "%L^n%L", LANG_PLAYER, "MPR_WAIT", LANG_PLAYER, "MPR_COUNTDOWN", g_countdown_seconds)
		
		if (g_countdown_seconds < g_countdown_sounds_size && g_countdown_sounds[g_countdown_seconds][0])
			client_cmd(0, "spk ^"%s^"", g_countdown_sounds[g_countdown_seconds])
		
		g_countdown_seconds--
		set_task(1.0, "CountDown", taskid)
	}
	else
		server_cmd("sv_restart 1")
}
