#include <amxmodx>
#include <fakemeta>

new cvar_render, Float:g_red, Float:g_green, Float:g_blue, Float:g_amount

public plugin_init()
{
	register_plugin("[ZPNM] Weaponbox Effects", "1.2", "D i 5 7 i n c T")
	
	cvar_render = register_cvar("zpnm_weaponbox_effects_render", "-1 0 0 57")
}

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	new settings[12], value1[3], value2[3], value3[3], value4[3]
	get_pcvar_string(cvar_render, settings, 11)
	parse(settings, value1, 2, value2, 2, value3, 2, value4, 2)
	
	g_red = float(clamp(str_to_num(value1), -1, 255))
	
	if (g_red > -1.0)
	{
		g_green = float(clamp(str_to_num(value2), 0, 255))
		g_blue = float(clamp(str_to_num(value3), 0, 255))
	}
	
	g_amount = float(clamp(str_to_num(value4), 0, 255))
}

// Forward Set Model
public fw_SetModel(entity, const model[])
{
	// We don't care
	if (strlen(model) < 8)
		return;
	
	// Get entity's classname
	static classname[14]
	pev(entity, pev_classname, classname, charsmax(classname))
	
	// Check if it's a weapon box
	if (equali(classname, "weaponbox") || equali(classname, "armoury_entity"))
	{
		if (g_red != -1.0)
			fm_set_rendering(entity, kRenderFxGlowShell, g_red, g_green, g_blue, kRenderNormal, g_amount)
		else
			fm_set_rendering(entity, kRenderFxGlowShell, random_float(57.7, 255.0), random_float(0.0, 255.0), random_float(0.0, 255.0), kRenderNormal, g_amount)
	}
}

// Set entity's rendering type (from fakemeta_util)
stock fm_set_rendering(entity, fx, Float:r, Float:g, Float:b, render, Float:amount)
{
	static Float:color[3]
	color[0] = r
	color[1] = g
	color[2] = b
	
	set_pev(entity, pev_renderfx, fx)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, render)
	set_pev(entity, pev_renderamt, amount)
}
