/*================================================================================
	
	------------------------------------
	-*- [ZPNM] Default Human Classes -*-
	------------------------------------
	
	~~~~~~~~~~~~~~~
	- Description -
	~~~~~~~~~~~~~~~
	
	This plugin adds the default human classes to Zombie Plague.
	Feel free to modify their attributes to your liking.
	
	Note: If human classes are disabled, the first registered class
	will be used for all players (by default, Normal Human).
	
================================================================================*/

#include <amxmodx>
#include <zombieplaguenightmare>

/*================================================================================
 [Plugin Customization]
=================================================================================*/

// Normal Human Attributes
new const hclass1_name[] = "Normal Human"
new const hclass1_info[] = "Average"
new const hclass1_model[] = "gsg9"
new const hclass1_handmodel[] = "v_knife.mdl"
const hclass1_health = 100
const hclass1_speed = 240
const Float:hclass1_gravity = 1.0

// Fast Human Attributes
new const hclass2_name[] = "Fast Human"
new const hclass2_info[] = "Runs faster"
new const hclass2_model[] = "guerilla"
new const hclass2_handmodel[] = "v_knife.mdl"
const hclass2_health = 100
const hclass2_speed = 250
const Float:hclass2_gravity = 1.0

// Gravity Human Attributes
new const hclass3_name[] = "Gravity Human"
new const hclass3_info[] = "Jumps higher"
new const hclass3_model[] = "terror"
new const hclass3_handmodel[] = "v_knife.mdl"
const hclass3_health = 100
const hclass3_speed = 240
const Float:hclass3_gravity = 0.75

// Slow Human Attributes
new const hclass4_name[] = "Slow Human"
new const hclass4_info[] = "Higher HP"
new const hclass4_model[] = "gign"
new const hclass4_handmodel[] = "v_knife.mdl"
const hclass4_health = 157
const hclass4_speed = 231
const Float:hclass4_gravity = 1.0

/*============================================================================*/

// Human Classes MUST be registered on plugin_precache
public plugin_precache()
{
	register_plugin("[ZPNM] Default Human Classes", "1.1", "MeRcyLeZZ, D i 5 7 i n c T")
	
	// Register all classes
	zpnm_register_human_class(hclass1_name, hclass1_info, hclass1_model, hclass1_handmodel, hclass1_health, hclass1_speed, hclass1_gravity)
	zpnm_register_human_class(hclass2_name, hclass2_info, hclass2_model, hclass2_handmodel, hclass2_health, hclass2_speed, hclass2_gravity)
	zpnm_register_human_class(hclass3_name, hclass3_info, hclass3_model, hclass3_handmodel, hclass3_health, hclass3_speed, hclass3_gravity)
	zpnm_register_human_class(hclass4_name, hclass4_info, hclass4_model, hclass4_handmodel, hclass4_health, hclass4_speed, hclass4_gravity)
}
