/*
To do:

T = needs testing
X = done
- = cancelled

[T] CZ bots support
v0.1.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <engine>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new g_pCvarJumpsMax, g_pCvarJumpsMaxResetBitsum, g_pCvarJumpsVelocity, g_iItemID, g_bEscapeMap, g_iJumps[33], g_iJumpsMax[33];

public plugin_init()
{
	register_plugin("[ZPNM] Item: MultiJump", "0.1.2", "twistedeuphoria, Dabbi, B!gBud, D i 5 7 i n c T")
	
	register_event("HLTV", "fw_EventRoundStart", "a", "1=0", "2=0")
	
	RegisterHam(Ham_Spawn, "player", "fw_HamPlayerSpawn_Post", 1)
	RegisterHam(Ham_Player_Jump, "player", "fw_HamPlayerJump_Post", 1)
	RegisterHam(Ham_Killed, "player", "fw_HamPlayerKilled_Post", 1)
	RegisterHamBots(Ham_Spawn, "fw_HamPlayerSpawn_Post", 1)
	RegisterHamBots(Ham_Player_Jump, "fw_HamPlayerJump_Post", 1)
	RegisterHamBots(Ham_Killed, "fw_HamPlayerKilled_Post", 1)
	
	g_pCvarJumpsMax = register_cvar("zpnm_jumps_max", "1");
	g_pCvarJumpsMaxResetBitsum = register_cvar("zpnm_jumps_max_reset", "172");
	g_pCvarJumpsVelocity = register_cvar("zpnm_jumps_velocity", "265.0");
	
	g_iItemID = zp_register_extra_item("Multi-jump \y(\w+1\y)", 5, ZP_TEAM_HUMAN | ZP_TEAM_SURVIVOR | ZP_TEAM_SNIPER | ZP_TEAM_ZOMBIE | ZP_TEAM_ASSASSIN);
	
	new szMapName[32];
	get_mapname(szMapName, 31)
	
	if (containi(szMapName, "escape") != -1 || containi(szMapName, "ze_") != -1 || containi(szMapName, "atix") != -1)
		g_bEscapeMap = true;
}

public fw_EventRoundStart()
{
	if (!(get_pcvar_num(g_pCvarJumpsMaxResetBitsum) & 1))
		return;
	
	static iMaxPlayers;
	if (!iMaxPlayers)
		iMaxPlayers = get_maxplayers();
	
	for (new iID = 1; iID <= iMaxPlayers; iID++)
		LoseItem(iID)
}

public client_disconnect(iID)
	LoseItem(iID)

public fw_HamPlayerSpawn_Post(iID)
{
	if (get_pcvar_num(g_pCvarJumpsMaxResetBitsum) & 2)
		LoseItem(iID)
}

public zp_extra_item_selected(iID, iItemID)
{
	if (iItemID != g_iItemID)
		return PLUGIN_CONTINUE;
	
	if (g_bEscapeMap)// && !(get_user_flags(iID) & ADMIN_RCON)
	{
		colored_chat(iID, "^3Multi-jumps are restricted on escape maps^1!")
		
		return ZP_PLUGIN_HANDLED;
	}
	else if (g_iJumpsMax[iID] == get_pcvar_num(g_pCvarJumpsMax))
	{
		colored_chat(iID, "^3You already have the maximum amount of multi-jumps^1(^3%d^1)!", g_iJumpsMax[iID])
		
		return ZP_PLUGIN_HANDLED;
	}
	
	g_iJumps[iID]++
	g_iJumpsMax[iID]++
	
	colored_chat(iID, "^4You can now jump^1 %d^4 time(s) in mid-air^1.", g_iJumpsMax[iID])
	
	return PLUGIN_CONTINUE;
}

public fw_HamPlayerJump_Post(iID)
{
	if (!g_iJumpsMax[iID])
		return;
	
	if (entity_get_int(iID, EV_INT_flags) & FL_ONGROUND)
	{
		g_iJumps[iID] = g_iJumpsMax[iID];
		
		return;
	}
	
	if (!g_iJumps[iID] || entity_get_int(iID, EV_INT_oldbuttons) & IN_JUMP)
		return;
	
	static Float:vVelocity[3];
	
	entity_get_vector(iID, EV_VEC_velocity, vVelocity)
	vVelocity[2] = get_pcvar_float(g_pCvarJumpsVelocity);
	
	entity_set_vector(iID, EV_VEC_velocity, vVelocity)
	
	g_iJumps[iID]--;
}

public zp_user_infected_pre(iID, iInfectorID, bNemesis, bAssassin)
{
	if (zp_get_user_zombie(iID))
		return;
	
	new iJumpsMaxResetBitsum = get_pcvar_num(g_pCvarJumpsMaxResetBitsum);
	
	if (!bAssassin && (!bNemesis && iJumpsMaxResetBitsum & 8 || bNemesis
	&& iJumpsMaxResetBitsum & 32) || bAssassin && iJumpsMaxResetBitsum & 128)
		LoseItem(iID)
}

public zp_user_humanized_pre(iID, bSurvivor, bSniper)
{
	if (!zp_get_user_zombie(iID))
		return;
	
	new iJumpsMaxResetBitsum = get_pcvar_num(g_pCvarJumpsMaxResetBitsum);
	
	if (!bSniper && (!bSurvivor && iJumpsMaxResetBitsum & 16 || bSurvivor
	&& iJumpsMaxResetBitsum & 64) || bSniper && iJumpsMaxResetBitsum & 256)
		LoseItem(iID)
}

public fw_HamPlayerKilled_Post(iID)
{
	if (get_pcvar_num(g_pCvarJumpsMaxResetBitsum) & 4)
		LoseItem(iID)
}

LoseItem(const iID)
{
	if (!g_iJumpsMax[iID])
		return;
	
	g_iJumps[iID] = 0;
	g_iJumpsMax[iID] = 0;
	
	colored_chat(iID, "^3You have lost your multi-jumps^1!")
}

stock colored_chat(const iTarget, const szMessage[], any:...)
{
	if (!is_user_connected(iTarget))
		return;
	
	static szBuffer[192];
	
	// Format message for player
	vformat(szBuffer, 191, szMessage, 3)
	
	new const D7_CHAT_TAG[] = "^1[^4ZPNM^1] "
	
	format(szBuffer, 191, "%s%s", D7_CHAT_TAG, szBuffer)
	
	static msgSayText;
	if (!msgSayText)
		msgSayText = get_user_msgid("SayText");
	
	message_begin(MSG_ONE, msgSayText, _, iTarget)
	write_byte(iTarget)
	write_string(szBuffer)
	message_end()
}
