/*
To do:

T = needs testing
X = done
- = cancelled

[T] CZ bots support
v1.0.1
[ ] 
*/

// Modules
#include <amxmodx>
#include <fun>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <zp50_colorchat>

// Radioactive Zombie Attributes
new const zclass_regen_name[] = "Regenerator Zombie" // name
new const zclass_regen_info[] = "Health regeneration" // description
new const zclass_regen_model[] = "zombie_source" // model
new const zclass_regen_clawmodel[] = "zombie_plague/v_knife_zombie.mdl" // claw model
const zclass_regen_health = 1800 // health
const zclass_regen_speed = 199 // speed
const Float:zclass_regen_gravity = 1.0 // gravity
const Float:zclass_regen_knockback = 1.0 // knockback

new cvar_health, cvar_delay, cvar_damage, Float:g_delay
new g_zclass_regen, g_extra_regen, g_regeneration[33], g_maxhealth[33]

public plugin_init()
{
	register_plugin("[ZPNM] Regeneration Zombie/Item", "1.0.1", "D i 5 7 i n c T")
	register_dictionary("zpnm_regeneration.txt")
	
//	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage_Post", 1)
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled_Post", 1)
//	RegisterHamBots(Ham_Spawn, "fw_PlayerSpawn_Post", 1)
	RegisterHamBots(Ham_TakeDamage, "fw_TakeDamage_Post", 1)
	RegisterHamBots(Ham_Killed, "fw_PlayerKilled_Post", 1)
	
	cvar_health = register_cvar("zpnm_regeneration_health", "50")
	cvar_delay = register_cvar("zpnm_regeneration_delay", "1.0")
	cvar_damage = register_cvar("zpnm_regeneration_damage_stop", "3")
	
	g_extra_regen = zp_register_extra_item("Health regeneration", 10, ZP_TEAM_ZOMBIE)
}

public plugin_precache()
	g_zclass_regen = zp_register_zombie_class(zclass_regen_name, zclass_regen_info, zclass_regen_model, zclass_regen_clawmodel, zclass_regen_health, zclass_regen_speed, zclass_regen_gravity, zclass_regen_knockback)

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	cvar_health = get_pcvar_num(cvar_health)
	g_delay = get_pcvar_float(cvar_delay)
	cvar_damage = get_pcvar_num(cvar_damage)
}

public client_disconnect(id)
{
	remove_task(id)
	g_regeneration[id] = false
}

public zpnm_user_spawn_post(id) //fw_PlayerSpawn_Post
{
	remove_task(id)
	g_regeneration[id] = false
}

public zp_user_infected_post(id, infector, nemesis, assassin)
{
	if (nemesis || assassin || zp_get_user_zombie_class(id) != g_zclass_regen)
	{
		remove_task(id)
		g_regeneration[id] = false
		
		return;
	}
	
	g_regeneration[id] = true
	g_maxhealth[id] = get_user_health(id)
	
	zp_colored_print(id, "^3%L", id, "ZPNM_REGENERATE_YOU_WILL", cvar_health, g_delay)
}

public zp_extra_item_selected(id, itemid)
{
	if (itemid != g_extra_regen)
		return PLUGIN_CONTINUE;
	
	if (g_regeneration[id])
	{
		client_print(id, print_center, "%L", id, "ZPNM_REGENERATE_ALREADY")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	g_regeneration[id] = true
	g_maxhealth[id] = zp_get_zombie_maxhealth(id)
	
	zp_colored_print(id, "^3%L", id, "ZPNM_REGENERATE_YOU_WILL", cvar_health, g_delay)
	
	if (get_user_health(id) < g_maxhealth[id])
		regenerate_health(id)
	
	return PLUGIN_CONTINUE;
}

public zp_user_humanized_post(id)
{
	remove_task(id)
	g_regeneration[id] = false
}

public fw_TakeDamage_Post(id)
{
	if (!g_regeneration[id] || get_user_health(id) >= g_maxhealth[id])
		return;
	
	if (task_exists(id))
	{
		if (!cvar_damage || cvar_damage != 3)
			return;
		
		remove_task(id)
		set_task(g_delay, "regenerate_health", id)
	}
	else
		set_task(g_delay, "regenerate_health", id)
}

public zpnm_user_burn(id)
{
	if (!g_regeneration[id] || get_user_health(id) >= g_maxhealth[id])
		return;
	
	if (task_exists(id))
	{
		if (cvar_damage < 2)
			return;
		
		remove_task(id)
		set_task(g_delay, "regenerate_health", id)
	}
	else
		set_task(g_delay, "regenerate_health", id)
}

public fw_PlayerKilled_Post(id)
{
	remove_task(id)
	g_regeneration[id] = false
}

public regenerate_health(id)
{
	static newhealth
	newhealth = get_user_health(id) + cvar_health
	
	set_user_health(id, newhealth)
	
	if (newhealth >= g_maxhealth[id])
		return;
	
	set_task(g_delay, "regenerate_health", id)
}
