/*
To do:

T = needs testing
X = done
- = cancelled

[T] CZ bots support
v1.5.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Class IDs
new g_iClassID;

new g_iHalfInfected[33], g_szPlayerModel[33][32], g_szPlayerKnifeModel[33][64];

new const g_szDefaultKnifeModel[] = "models/p_knife.mdl";

// Zombie Classes MUST be registered on plugin_precache
public plugin_precache()
{
	// Zombie Attributes
	new const zclass_name[] = "Half Infected Zombie" // name
	new const zclass_info[] = "Looks like humans" // description
	new const zclass_model[] = "zombie_source" // model
	new const zclass_clawmodel[] = "v_knife.mdl" // claw model
	const zclass_health = 1600 // health
	const zclass_speed = 190 // speed
	const Float:zclass_gravity = 1.0 // gravity
	const Float:zclass_knockback = 1.0 // knockback
	
	// Register the new class and store ID for reference
	g_iClassID = zp_register_zombie_class(zclass_name, zclass_info, zclass_model, zclass_clawmodel, zclass_health, zclass_speed, zclass_gravity, zclass_knockback)
	
	precache_model(g_szDefaultKnifeModel)
}

public plugin_init()
{
	register_plugin("[ZPNM] Half Infected Zombie", "1.5.2", "D i 5 7 i n c T")
	
	register_message(get_user_msgid("CurWeapon"), "message_cur_weapon")
	
	RegisterHam(Ham_Spawn, "player", "OnPlayerSpawn", 1)
	RegisterHam(Ham_Killed, "player", "OnPlayerKilled", 1)
	RegisterHamBots(Ham_Spawn, "OnPlayerSpawn", 1)
	RegisterHamBots(Ham_Killed, "OnPlayerKilled", 1)
}

public OnPlayerSpawn(id)
	g_iHalfInfected[id] = false;

public zp_user_infected_pre(id, infector, nemesis, assassin)
{
	// Check if the infected player is using our custom zombie class
	if (nemesis || assassin || zp_get_user_zombie_class(id) != g_iClassID || zp_get_user_zombie(id))
		return;
	
	zpnm_get_user_model(id, g_szPlayerModel[id], 31)
	
	if (get_user_weapon(id) != CSW_KNIFE)
		engclient_cmd(id, "weapon_knife")
	
	// Make sure we drop any custom weapons like bazooka, etc
	// so we won't have a zombie running around with them
	engclient_cmd(id, "drop; drop; drop; drop; drop; drop; drop")
	
	pev(id, pev_weaponmodel2, g_szPlayerKnifeModel[id], 63)
}

// User Infected forward
public zp_user_infected_post(id, infector, nemesis, assassin)
{
	// Check if the infected player is using our custom zombie class
	if (nemesis || assassin || zp_get_user_zombie_class(id) != g_iClassID)
	{
		g_iHalfInfected[id] = false;
		
		return;
	}
	
	g_iHalfInfected[id] = true;
	
	zp_override_user_model(id, g_szPlayerModel[id], 31)
	
	if (get_user_weapon(id) == CSW_KNIFE)
	{
		if (g_szPlayerKnifeModel[id][0])
			set_pev(id, pev_weaponmodel2, g_szPlayerKnifeModel[id])
		else
			set_pev(id, pev_weaponmodel2, g_szDefaultKnifeModel)
	}
}

public zp_user_humanized_post(id)
	g_iHalfInfected[id] = false;

public OnPlayerKilled(id)
	g_iHalfInfected[id] = false;

public message_cur_weapon(msgid, dest, entity)
{
	// Not an active weapon
	if (get_msg_arg_int(1) != 1 || !g_iHalfInfected[entity] || get_user_weapon(entity) != CSW_KNIFE)
		return;
	
	if (g_szPlayerKnifeModel[entity][0])
		set_pev(entity, pev_weaponmodel2, g_szPlayerKnifeModel[entity])
	else
		set_pev(entity, pev_weaponmodel2, g_szDefaultKnifeModel)
}
